/*************************************************************************
 * The contents of this file are subject to the MYRICOM DBL              *
 * NETWORKING SOFTWARE AND DOCUMENTATION LICENSE (the "License");        *
 * User may not use this file except in compliance with the              *
 * License.  The full text of the License can found in LICENSE.TXT       *
 *                                                                       *
 * Software distributed under the License is distributed on an "AS IS"   *
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See  *
 * the License for the specific language governing rights and            *
 * limitations under the License.                                        *
 *                                                                       *
 * Copyright 2009 by Myricom, Inc.  All rights reserved.                 *
 *************************************************************************/

#ifndef _mal__compat_h
#define _mal__compat_h
#include "mal_auto_config.h"
#include "mal_thread.h"

#if !MAL_OS_WINDOWS
#include <sys/socket.h>
#include <netinet/in.h>
#include <net/if.h>
#include <net/if_arp.h>
#include <net/route.h>
#include <arpa/inet.h>
#if !MAL_OS_SOLARIS
#include <ifaddrs.h>
#endif
#include <sys/ioctl.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#ifdef HAVE_SYS_SOCKIO_H
# include <sys/sockio.h>
#endif
#define closesocket close
#else /* MAL_OS_WINDOWS */
#include <winsock2.h>
#include <ws2tcpip.h>
#include <ws2ipdef.h>
#include <iphlpapi.h>
#define strcasecmp _stricmp
#define EAFNOSUPPORT WSAEAFNOSUPPORT
#define EADDRINUSE WSAEADDRINUSE
#define ENOTCONN WSAENOTCONN
#define ETIMEDOUT WSAETIMEDOUT
#define usleep(x) Sleep(x/1000)
#endif

#include <string.h>
#include <stdio.h>

#include "mal.h"
#include "mal_io.h"
#include "mal_timing.h"
#include "mal_stbar.h"
#include "mal_byteswap.h"
#include "mcp_config.h"
#ifndef MYRI_PHOENIX
#include "mcp_requests.h"
#include "mcp_events.h"
#endif
#if MAL_OS_WINDOWS
#undef SLIST_ENTRY
#endif
#include "bsd/queue.h"

#ifndef ETH_ALEN
#define ETH_ALEN 6
#endif

#endif /* _mal__compat_h */
