/*************************************************************************
 * The contents of this file are subject to the MYRICOM ABSTRACTION      *
 * LAYER (MAL) SOFTWARE AND DOCUMENTATION LICENSE (the "License").       *
 * User may not use this file except in compliance with the License.     *
 * The full text of the License can found in LICENSE.TXT                 *
 *                                                                       *
 * Software distributed under the License is distributed on an "AS IS"   *
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See  *
 * the License for the specific language governing rights and            *
 * limitations under the License.                                        *
 *                                                                       *
 * Copyright 2003 - 2009 by Myricom, Inc.  All rights reserved.          *
 * Copyright 2015 by CSP, Inc.  All rights reserved.                     *
 *************************************************************************/

#ifndef _mal_ifaddrs_h_
#define _mal_ifaddrs_h_

struct mal_ifaddrs {
  /* clones from getifaddrs(), or emulation thereof */
  struct mal_ifaddrs *mal_ifa_next;  /* Next item in list, or NULL if last */
  const char         *mal_ifa_name;  /* Interface name, as per ifconfig */
  uint32_t            mal_ifa_flags;
  uint32_t            mal_ifa_ipaddr;
  uint32_t            mal_ifa_netmask;
  uint32_t            mal_ifa_bcastaddr;

  /* Mal-specific fields */
  uint32_t            mal_ifa_boardnum;
  uint64_t            mal_ifa_nicid;
  uint8_t             mal_ifa_macaddr[6];
  uint8_t             pad[2];
  uint32_t            mal_ifa_max_endpoints;
  uint32_t            mal_ifa_link_state; /* 0 is down, 1 is up */
#ifdef _WIN32
  int ifindex;
#endif
  uint32_t            mal_ifa_snf_maxring;
  uint32_t            mal_ifa_snf_maxinject;
  uint64_t            mal_ifa_link_speed;
};

#define MAL_IFA_FLAG_MULTICAST 0x1
#define MAL_IFA_FLAG_BROADCAST 0x2

MAL_FUNC(int) mal_getifaddrs(struct mal_ifaddrs **ifaddrs_o, int inet_only, int *num_ifs);
MAL_FUNC(void) mal_freeifaddrs(struct mal_ifaddrs *ifaddrs);
MAL_FUNC(int) mal_ifaddr_to_macaddr(uint32_t ipaddr, uint8_t *mac) ;

#endif /* _mal_ifaddrs_h_ */
