#ifndef _mal_sock_funcs_h_
#define _mal_sock_funcs_h_

#include "mal_types.h"

typedef struct mal_socket_functions_ {
  int (*dup) (int oldfd);
  int (*dup2) (int oldfd, int newfd);

  mal_socket_t (*socket)(int af, int type, int protocol) ;
  int (*bind) (mal_socket_t s, const struct sockaddr *my_addr, mal_socklen_t addrlen);
  int (*listen) (mal_socket_t s, int backlog);
  int (*connect) (mal_socket_t s, const struct sockaddr *name, mal_socklen_t namelen);
  mal_socket_t (*accept) (mal_socket_t s, struct sockaddr *addr, mal_socklen_t *addrlen);

  mal_ret_len_t (*recvfrom) (mal_socket_t s,  void *buf, mal_len_t len, int flags, struct sockaddr *from, mal_socklen_t *fromlen);
  mal_ret_len_t (*sendto) (mal_socket_t s, const void *msg, mal_len_t len, int flags, const struct sockaddr*to, mal_socklen_t tolen);
  mal_ret_len_t (*recv) (mal_socket_t s, void *buf, mal_len_t len, int flags);
  mal_ret_len_t (*send) (mal_socket_t s, const void *msg, mal_len_t len, int flags);

  int (*close) (int s) ;
  int (*getsockname) (mal_socket_t s, struct sockaddr *name, mal_socklen_t *namelen);
  int (*getpeername) (mal_socket_t s, struct sockaddr *name, mal_socklen_t *namelen);
  int (*setsockopt) (mal_socket_t s, int  level,  int  optname,  const  void  *optval, mal_socklen_t optlen);
  int (*getsockopt) (mal_socket_t s, int level, int optname, void *optval, mal_socklen_t *optlen);
  int (*select) (int nfds, fd_set *readfds, fd_set *writefds,
                 fd_set *exceptfds, struct timeval *timeout);
  int (*ioctl) (int s, unsigned long cmd, ...);
} mal_socket_functions_t;

extern mal_socket_functions_t _mal_fops;

#endif /* _mal_sock_funcs_h_ */
