/*************************************************************************
 * The contents of this file are subject to the MYRICOM ABSTRACTION      *
 * LAYER (MAL) SOFTWARE AND DOCUMENTATION LICENSE (the "License").       *
 * User may not use this file except in compliance with the License.     *
 * The full text of the License can found in LICENSE.TXT                 *
 *                                                                       *
 * Software distributed under the License is distributed on an "AS IS"   *
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See  *
 * the License for the specific language governing rights and            *
 * limitations under the License.                                        *
 *                                                                       *
 * Copyright 2003 - 2012 by Myricom, Inc.  All rights reserved.          *
 *************************************************************************/

#ifndef _mal_types_h_
#define _mal_types_h_

#include "mal_auto_config.h"

#if MAL_OS_WINDOWS

typedef HANDLE mal_handle_t;
typedef SOCKET mal_socket_t;
typedef int mal_len_t;
typedef int mal_ret_len_t;
typedef int mal_socklen_t;

#define mal_snprintf _snprintf

#ifndef EADDRNOTAVAIL
#define EADDRNOTAVAIL 99
#endif

#ifdef ENETUNREACH
#undef ENETUNREACH
#endif
#define ENETUNREACH 101
#ifdef EHOSTUNREACH
#undef EHOSTUNREACH
#endif
#define EHOSTUNREACH 113

#else

typedef int mal_handle_t;
typedef int mal_socket_t;
typedef size_t mal_len_t;
typedef ssize_t mal_ret_len_t;
typedef socklen_t mal_socklen_t;

#define mal_snprintf snprintf
#endif

#define MAL_INVALID_HANDLE ((mal_handle_t) -1)
#define MX__INVALID_HANDLE MAL_INVALID_HANDLE

#endif /* _mal_types_h_ */
