
#undef TRACEPOINT_PROVIDER
#define TRACEPOINT_PROVIDER snf

#undef TRACEPOINT_INCLUDE
#define TRACEPOINT_INCLUDE "snf_tracepoints.h"

#if !defined(_SNF_TP_H) || defined(TRACEPOINT_HEADER_MULTI_READ)
#define _SNF_TP_H

#include <lttng/tracepoint.h>
TRACEPOINT_EVENT(
    snf,
    code_marker,
    TP_ARGS(
        int, my_integer_arg,
        char*, my_string_arg
    ),
    TP_FIELDS(
        ctf_string(marker, my_string_arg)
        ctf_integer(int, value, my_integer_arg)
    )
)

TRACEPOINT_EVENT(
    snf,
    code_marker_hex,
    TP_ARGS(
        int, my_integer_arg,
        char*, my_string_arg
    ),
    TP_FIELDS(
        ctf_string(marker, my_string_arg)
        ctf_integer_hex(int, value, my_integer_arg)
    )
)

TRACEPOINT_EVENT(
    snf,
    touch_packet,
    TP_ARGS(
        int, packet,
        int, thread,
        int, endpoint,
        int, hashval
    ),
    TP_FIELDS(
        ctf_integer(int, packet, packet)
        ctf_integer(int, worker, thread)
        ctf_integer(int, ring, endpoint)
        ctf_integer_hex(int, hashval, hashval)
    )
)

#endif /* _SNF_TP_H */

#include <lttng/tracepoint-event.h>
